package Cpu.IO is

   type Byte is mod 2 ** 8;
   for Byte'Size use 8;
   type Port_Ref is (P_A, P_B, P_C, P_D, 
		     BAUD, SCCR1, SCCR2, SCSR, SCDR);
   for Port_Ref use (P_A => 0,
		     P_B => 1,
		     P_C => 2,
		     P_D => 3,
		     BAUD  => 16#2B#,
		     SCCR1 => 16#2C#,
		     SCCR2 => 16#2D#,
		     SCSR  => 16#2E#,
		     SCDR  => 16#2F#);

   SCCR1_R8 : constant Byte := 16#80#;
   SCCR1_T8 : constant Byte := 16#40#;
   SCCR1_M  : constant Byte := 16#10#;
   SCCR1_WAKE : constant Byte := 16#08#;

   TDRE  : constant Byte := 16#80#;
   TC    : constant Byte := 16#40#;
   
   TIE   : constant Byte := 16#80#;
   TCIE  : constant Byte := 16#40#;
   RIE   : constant Byte := 16#20#;
   ILIE  : constant Byte := 16#10#;
   TE    : constant Byte := 16#08#;
   RE    : constant Byte := 16#04#;
   RWU   : constant Byte := 16#02#;
   SBK   : constant Byte := 16#01#;

   type Port is array (Port_Ref) of Byte;

   Io_Ports : Port;
   pragma Import (C, Io_Ports, "_io_ports");

end Cpu.IO;
