--  BSP -- Board Support Package
--  Copyright (C) 2001, 2002 Free Software Foundation, Inc.
--  Written by Stephane Carrez (stcarrez@nerim.fr)
--
--  This file is free software; you can redistribute it and/or modify it
--  under the terms of the GNU General Public License as published by the
--  Free Software Foundation; either version 2, or (at your option) any
--  later version.
--
--  In addition to the permissions in the GNU General Public License, the
--  Free Software Foundation gives you unlimited permission to link the
--  compiled version of this file with other programs, and to distribute
--  those programs without any restriction coming from the use of this
--  file.  (The General Public License restrictions do apply in other
--  respects; for example, they cover modification of the file, and
--  distribution when not linked into another program.)
--
--  This file is distributed in the hope that it will be useful, but
--  WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
--  General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; see the file COPYING.  If not, write to
--  the Free Software Foundation, 59 Temple Place - Suite 330,
--  Boston, MA 02111-1307, USA.  */
pragma No_Run_Time;
with System; use System;
package BSP.Task is

   type Task_Controller is record
   end record;
   type Task_Controller_Ptr is access all Task_Controller;

   procedure Schedule (Controller : in out Task_Controller);

   type Task_D is record
      Context    : Address;
      Controller : Task_Controller_Ptr;
   end record;

   procedure Create (T : out Task_D);

   procedure Destroy (T : in out Task_D);

   procedure Suspend (T : in out Task_D);

   procedure Resume (T : in out Task_D);

   type Mutex is private;

   procedure Lock (M : in out Mutex);

   procedure Unlock (M : in out Mutex);

private

   type Mutex is record
      Locked : Boolean := False;
   end record;

   procedure Lock (M : in out Mutex) is
   begin
      
   procedure Unlock (M : in out Mutex);

end BSP.Task;
