/* Compute and print stack depth of program
   Copyright (C) 2001, 2002 Free Software Foundation, Inc.
   Written by Stephane Carrez (stcarrez@nerim.fr)	

This file is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

In addition to the permissions in the GNU General Public License, the
Free Software Foundation gives you unlimited permission to link the
compiled version of this file with other programs, and to distribute
those programs without any restriction coming from the use of this
file.  (The General Public License restrictions do apply in other
respects; for example, they cover modification of the file, and
distribution when not linked into another program.)

This file is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

/*! @page stack_depth Compute and print stack depth of program.


  @htmlonly
  Source file: <a href="primes_8c-source.html">primes.c</a>
  @endhtmlonly

*/
/*@{*/

#include <stdio.h>
#include <stdarg.h>
#include <sys/param.h>
#include <sys/sio.h>
#include <string.h>

char *stack_low = (char*) 0xffff;
extern char _stack;

static void
print_stack_size ()
{
  unsigned short sz;

  sz = (unsigned short) (&_stack - stack_low);
  printf ("Stack size = %ld\n", (long) sz);
}

static unsigned long
fact (unsigned long n)
{
  /* Buffer to use some stack space.  */
  char buf[10];

  memset (buf, 0, sizeof (buf));
  if (n > 1)
    n = n * fact (n - 1);
  else
    n = 1;

  return n;
}

int
main ()
{
  long i;
  unsigned long val;

  serial_init ();
  for (i = 1; i < 10; i++)
    {
      val = fact (i);
      printf ("Fact %ld = %ld\t", i, val);
      print_stack_size ();
      stack_low = &_stack;
    }
  return 0;
}
/*@}*/
